<!doctype html>
<html lang="es">

<head>
    <meta charset='utf-8'>
    <title>Estilos: Transiciones</title>
    <link rel='stylesheet' href='css/style.css'>
    <link rel='stylesheet' href='css/print.css' media='print'>
</head>

<body>


    <article class='reveal'>

        <section data-bespoke-state='portada'>
            <h1>Estilos: Transiciones</h1>
        </section>

        <section data-bespoke-state='clean'>
            <h2><span class="propiedad">transition-property</span></h2>
            <ul class="lista">
                <li>Elije la propiedad que se verá afectada por la transición</li>
                <li>Valores:
                    <ul>
                        <li><span class="valor-css">all</span>, todas las propiedades</li>
                        <li><span class="valor-css"><strong>none</strong></span>, ninguna (por defecto)</li>
                        <li><span class="valor-css">[nombre-propiedad]</span>, la transición afecta a la propiedad indicada</li>
                    </ul>
                </li>
                <li>Se pueden poner varios valores separados por comas</li>
            </ul>
        </section>        

        <section data-bespoke-state='clean'>
            <h2><a href="ejemplos/p23_transition_property.html" target="_blank">Ejemplos</a></h2>
            <iframe src="ejemplos/p23_transition_property.html" style="height: 95%; width: 450px;"></iframe>
        </section>

        <section data-bespoke-state='clean'>
            <h2><span class="propiedad">transition-duration</span></h2>
            <ul class="lista">
                <li>Establece lo que durará la transición</li>
                <li>Se declara con un número seguido de una 's'</li>
                <li>Por defecto vale <span class="valor-css">0s</span></li>
            </ul>
        </section>

        <section data-bespoke-state='clean'>
            <h2><a href="ejemplos/p23_transition_duration.html" target="_blank">Ejemplos</a></h2>
            <iframe src="ejemplos/p23_transition_duration.html" style="height: 95%; width: 450px;"></iframe>
        </section>

        <section data-bespoke-state='clean'>
            <h2><span class="propiedad">transition-timing-function</span></h2>
            <ul class="lista">
                <li>Establece el ritmo de la transición</li>
                <li>Se distinguen tres momentos, inicial, medio y final</li>
                <li>Valores:
                    <ul>
                        <li><span class="valor-css"><strong>ease</strong></span>, lento en el inicial y final y rápido en el medio (por defecto)</li>
                        <li><span class="valor-css">linear</span>, normal en los tres momentos</li>
                        <li><span class="valor-css">ease-in</span>, lento en el inicial y normal en el resto</li>
                        <li><span class="valor-css">ease-out</span>, lento en el final y normal en el resto</li>
                        <li><span class="valor-css">ease-in-out</span>, lento en el inicial y final y normal en el medio</li>
                    </ul>
                </li>
            </ul>
        </section>

        <section data-bespoke-state='clean'>
            <h2><span class="propiedad">transition-timing-function</span></h2>
            <div class="importante valor-css">cubic-bezier([velIni],[velMed],[velFin],[dura])</div>
            <ul class="lista">
                <li>[velIni], velocidad en el inicio</li>
                <li>[velMed], velocidad en el medio</li>
                <li>[velFin], velocidad al final</li>
                <li>[dura], duración</li>
            </ul>
            <h3>Ejemplos</h3>
            <ul class="lista">
                <li><span class="valor-css"><strong>ease</strong></span> = <span class="valor-css">cubic-bezier(0.25, 0.1, 0.25, 1)</span></li>
                <li><span class="valor-css">linear</span> = <span class="valor-css">cubic-bezier(0, 0, 1, 1)</span></li>
                <li><span class="valor-css">ease-in</span> = <span class="valor-css">cubic-bezier(0.42, 0, 1, 1)</span></li>
                <li><span class="valor-css">ease-out</span> = <span class="valor-css">cubic-bezier(0, 0, 0.58, 1)</span></li>
                <li><span class="valor-css">ease-in-out</span> = <span class="valor-css">cubic-bezier(0.42, 0, 0.58, 1)</span></li>
            </ul>
        </section>

        <section data-bespoke-state='clean'>
            <h2><a href="ejemplos/p23_transition_timing_function.html" target="_blank">Ejemplos</a></h2>
            <iframe src="ejemplos/p23_transition_timing_function.html" style="height: 95%; width: 800px;"></iframe>
        </section>

        <section data-bespoke-state='clean'>
            <h2><span class="propiedad">transition-delay</span></h2>
            <ul class="lista">
                <li>Establece lo que se demorará la transición en empezar</li>
                <li>Por defecto <span class="valor-css">0</span></li>
            </ul>
            <h3><a href="ejemplos/p23_transition_delay.html" target="_blank">Ejemplos</a></h3>
            <iframe src="ejemplos/p23_transition_delay.html" style="height: 95%; width: 450px;"></iframe>
        </section>

        <section data-bespoke-state='clean'>
            <h2><span class="propiedad">transition</span></h2>
            <ul class="lista">
                <li>Atajo para las propiedades:
                    <ul>
                        <li><span class="propiedad">transition-property</span></li>
                        <li><span class="propiedad">transition-duration</span></li>
                        <li><span class="propiedad">transition-timing-function</span></li>
                        <li><span class="propiedad">transition-delay</span></li>
                    </ul>
                </li>
                <li>Puede contener varias transiciones separadas por comas</li>
            </ul>
        </section>

    </article>


    <script src='js/slides.keys.js'></script>
    <script src='js/slides.classes.js'></script>
    <script src='js/slides.state.js'></script>
    <script src='js/slides.kernel.js'></script>
    <script src='js/slides.jump.js'></script>
    <script src='js/slides.swipe.js'></script>

    <script>
        const {
            Deck,
            classes,
            keys,
            state,
            jump,
            swipe
        } = S6;
        const deck = new Deck({
            parent: 'article',
            plugins: [classes(), keys(), state(), jump(), swipe()]
        });

        function resize(control, idContenedor) {
            var x = document.getElementById(idContenedor);
            x.style.width = control.value + "px";
        }
    </script>
</body>

</html>